//////////////////////////////////////////////////////////////////
// mysql JDBC Driver
//
// Version : 0.9.2
//
// JDBC : 1.22
//
// LastModified: 12.03.1997
//
// Copyright (c) 1997 GWE Technologies Ltd. All rights reserved
// See http://gwe.co.uk/mysql/jdbc/copyright.html for full details

package gwe.sql;

import java.sql.*;
import java.util.*;
import javax.sql.ConnectionEventListener;
import javax.sql.PooledConnection;

public class gweMysqlPooledConnection implements PooledConnection, Connection {

  private Connection org_conn = null;
  private gweMysqlConnectionPoolDataSource pool = null;

  public gweMysqlPooledConnection(gweMysqlConnectionPoolDataSource pool,
                                  Connection org_conn) {
    this.pool = pool;
    this.org_conn = org_conn;
  }

  public int hashCode() {
    return org_conn.hashCode();
  }

  public boolean equals(Object obj) {
    if( obj != null && obj instanceof gweMysqlPooledConnection )
    {
      gweMysqlPooledConnection that = (gweMysqlPooledConnection)obj;
      return (this.org_conn == that.org_conn);
    }
    return false;
  }

  public void close() throws java.sql.SQLException {
    //org_conn.close();
    pool.storeConnection(this);
  }

  Connection getOrgConnection() {
    return org_conn;
  }

  public Connection getConnection() throws java.sql.SQLException {
    return this;
  }

  public boolean isClosed() throws SQLException {
    //boolean retval = org_conn.isClosed();
    return org_conn == null;
  }

  public void addConnectionEventListener(ConnectionEventListener parm1) {
    ;
  }

  public void removeConnectionEventListener(ConnectionEventListener parm1) {
    ;
  }

  public Statement createStatement() throws SQLException {
    Statement retval = org_conn.createStatement();
    return retval;
  }
  public PreparedStatement prepareStatement(String sql) throws SQLException {
    PreparedStatement retval = org_conn.prepareStatement(sql);
    return retval;
  }
  public CallableStatement prepareCall(String sql) throws SQLException {
    CallableStatement retval = org_conn.prepareCall(sql);
    return retval;
  }
  public String nativeSQL(String sql) throws SQLException {
    String retval = org_conn.nativeSQL(sql);
    return retval;
  }
  public void setAutoCommit(boolean autoCommit) throws SQLException {
    org_conn.setAutoCommit(autoCommit);
  }
  public boolean getAutoCommit() throws SQLException {
    boolean retval = org_conn.getAutoCommit();
    return retval;
  }
  public void commit() throws SQLException {
    org_conn.commit();
  }
  public void rollback() throws SQLException {
    org_conn.rollback();
  }
  public DatabaseMetaData getMetaData() throws SQLException {
    DatabaseMetaData retval = org_conn.getMetaData();
    return retval;
  }
  public void setReadOnly(boolean readOnly) throws SQLException {
    org_conn.setReadOnly(readOnly);
  }
  public boolean isReadOnly() throws SQLException {
    boolean retval = org_conn.isReadOnly();
    return retval;
  }
  public void setCatalog(String catalog) throws SQLException {
    org_conn.setCatalog(catalog);
  }
  public String getCatalog() throws SQLException {
    String retval = org_conn.getCatalog();
    return retval;
  }
  public void setTransactionIsolation(int level) throws SQLException {
    org_conn.setTransactionIsolation(level);
  }
  public int getTransactionIsolation() throws SQLException {
    int retval = org_conn.getTransactionIsolation();
    return retval;
  }
  public SQLWarning getWarnings() throws SQLException {
    SQLWarning retval = org_conn.getWarnings();
    return retval;
  }
  public void clearWarnings() throws SQLException {
    org_conn.clearWarnings();
  }
  public Statement createStatement(int resultSetType, int resultSetConcurrency) throws SQLException {
    Statement retval = org_conn.createStatement(resultSetType, resultSetConcurrency);
    return retval;
  }
  public PreparedStatement prepareStatement(String sql, int resultSetType, int resultSetConcurrency) throws SQLException {
    PreparedStatement retval = org_conn.prepareStatement(sql, resultSetType, resultSetConcurrency);
    return retval;
  }
  public CallableStatement prepareCall(String sql, int resultSetType, int resultSetConcurrency) throws SQLException {
    CallableStatement retval = org_conn.prepareCall(sql, resultSetType, resultSetConcurrency);
    return retval;
  }
  public Map getTypeMap() throws SQLException {
    Map retval = org_conn.getTypeMap();
    return retval;
  }
  public void setTypeMap(Map map) throws SQLException {
    org_conn.setTypeMap(map);
  }
}
