//////////////////////////////////////////////////////////////////
// mysql JDBC Driver
//
// Version : 0.9.2
//
// JDBC : 1.22
//
// LastModified: 16.03.1997
//
// Copyright (c) 1997 GWE Technologies Ltd. All rights reserved
// See http://gwe.co.uk/mysql/jdbc/copyright.html for full details

package gwe.sql;

import java.sql.*;
import java.io.*;
import java.util.ArrayList;
import java.util.Map;
import java.util.Calendar;
import java.math.BigDecimal;

public class gweMysqlVectorResultSet implements ResultSet, ResultSetMetaData {

  private gweMysqlConnection conn;
  private gweMysqlColumn[] cols;
  private ArrayList rows;
  private int index;

  public gweMysqlVectorResultSet(gweMysqlConnection org_conn,
                                 gweMysqlColumn[] org_cols, ArrayList org_rows) {
    conn = org_conn;
    cols = org_cols;
    rows = org_rows;
    index = 0;
  }

  /////////////// implements ResultSet //////////////////////////////////////
  public boolean next() throws SQLException {
    int row_count = rows.size();
    index++;
    if( index <= row_count )
      return true;
    return false;
  }

  public void close() throws SQLException {
  }

  public boolean wasNull() throws SQLException {
    return false;
  }

  private int getColumnIndex(String columnName) {
    int retval = -1;
    for(int i = 0; i < cols.length; i++)
    {
      gweMysqlColumn coldata = cols[i];
      if( coldata.getName().equals(columnName) == true )
      {
        retval = i + 1;
        break;
      }
    }
    return retval;
  }

  public String getString(int columnIndex) throws SQLException {
    try {
      ArrayList rowdata = (ArrayList)rows.get(index-1);
      Object data = rowdata.get(columnIndex-1);
      if( data == null )
        return "";
      return data.toString();
    }
    catch(Exception e) {
      e.printStackTrace();
      throw new SQLException(e.getMessage());
    }
  }

  public boolean getBoolean(int columnIndex) throws SQLException {
    String s = getString(columnIndex);
    try {
      return Boolean.valueOf(s).booleanValue();
    }
    catch(Exception e) {
      throw new SQLException(e.getMessage());
    }
  }

  public byte getByte(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public short getShort(int columnIndex) throws SQLException {
    String s = getString(columnIndex);
    try {
      return Short.valueOf(s).shortValue();
    }
    catch(Exception e) {
      throw new SQLException(e.getMessage());
    }
  }

  public int getInt(int columnIndex) throws SQLException {
    String s = getString(columnIndex);
    try {
      return Integer.valueOf(s).intValue();
    }
    catch(Exception e) {
      throw new SQLException(e.getMessage());
    }
  }

  public long getLong(int columnIndex) throws SQLException {
    String s = getString(columnIndex);
    try {
      return Long.valueOf(s).longValue();
    }
    catch(Exception e) {
      throw new SQLException(e.getMessage());
    }
  }

  public float getFloat(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public double getDouble(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public BigDecimal getBigDecimal(int columnIndex, int scale)
                                                        throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public byte[] getBytes(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Date getDate(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Time getTime(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Timestamp getTimestamp(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public InputStream getAsciiStream(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public InputStream getUnicodeStream(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public InputStream getBinaryStream(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public String getString(String columnName) throws SQLException {
    return getString(getColumnIndex(columnName));
  }

  public boolean getBoolean(String columnName) throws SQLException {
    return getBoolean(getColumnIndex(columnName));
  }

  public byte getByte(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public short getShort(String columnName) throws SQLException {
    return getShort(getColumnIndex(columnName));
  }

  public int getInt(String columnName) throws SQLException {
    return getInt(getColumnIndex(columnName));
  }

  public long getLong(String columnName) throws SQLException {
    return getLong(getColumnIndex(columnName));
  }

  public float getFloat(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public double getDouble(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public BigDecimal getBigDecimal(String columnName, int scale)
                                                         throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public byte[] getBytes(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Date getDate(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Time getTime(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Timestamp getTimestamp(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public InputStream getAsciiStream(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public InputStream getUnicodeStream(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public InputStream getBinaryStream(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public SQLWarning getWarnings() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void clearWarnings() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public String getCursorName() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public ResultSetMetaData getMetaData() throws SQLException {
    return this;
  }

  public Object getObject(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Object getObject(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public int findColumn(String columnName) throws SQLException {
    return 0;
  }

  public Reader getCharacterStream(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Reader getCharacterStream(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public BigDecimal getBigDecimal(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public BigDecimal getBigDecimal(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public boolean isBeforeFirst() throws SQLException {
    return false;
  }

  public boolean isAfterLast() throws SQLException {
    return false;
  }

  public boolean isFirst() throws SQLException {
    return false;
  }

  public boolean isLast() throws SQLException {
    return false;
  }

  public void beforeFirst() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void afterLast() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public boolean first() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public boolean last() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public int getRow() throws SQLException {
    return 0;
  }

  public boolean absolute(int row) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public boolean relative(int rows) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public boolean previous() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void setFetchDirection(int direction) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public int getFetchDirection() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void setFetchSize(int rows) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public int getFetchSize() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public int getType() throws SQLException {
    return 0;
  }

  public int getConcurrency() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public boolean rowUpdated() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public boolean rowInserted() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public boolean rowDeleted() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateNull(int columnIndex) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateBoolean(int columnIndex, boolean x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateByte(int columnIndex, byte x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateShort(int columnIndex, short x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateInt(int columnIndex, int x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateLong(int columnIndex, long x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateFloat(int columnIndex, float x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateDouble(int columnIndex, double x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateBigDecimal(int columnIndex, BigDecimal x)
                                                       throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateString(int columnIndex, String x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateBytes(int columnIndex, byte[] x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateDate(int columnIndex, Date x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateTime(int columnIndex, Time x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateTimestamp(int columnIndex, Timestamp x)
                                                      throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateAsciiStream(int columnIndex, InputStream x, int length)
                                                      throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }
  public void updateBinaryStream(int columnIndex, InputStream x, int length)
                                                      throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateCharacterStream(int columnIndex, Reader x, int length)
                                                      throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateObject(int columnIndex, Object x, int scale)
                                                      throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateObject(int columnIndex, Object x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateNull(String columnName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateBoolean(String columnName, boolean x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateByte(String columnName, byte x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateShort(String columnName, short x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateInt(String columnName, int x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateLong(String columnName, long x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateFloat(String columnName, float x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateDouble(String columnName, double x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateBigDecimal(String columnName, BigDecimal x)
                                                        throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateString(String columnName, String x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateBytes(String columnName, byte[] x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateDate(String columnName, Date x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateTime(String columnName, Time x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateTimestamp(String columnName, Timestamp x)
                                                    throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateAsciiStream(String columnName, InputStream x, int length)
                                                     throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateBinaryStream(String columnName, InputStream x, int length)
                                                      throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateCharacterStream(String columnName, Reader reader, int length) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateObject(String columnName, Object x, int scale)
                                                      throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateObject(String columnName, Object x) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void insertRow() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void updateRow() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void deleteRow() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void refreshRow() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void cancelRowUpdates() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void moveToInsertRow() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public void moveToCurrentRow() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Statement getStatement() throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Object getObject(int i, Map map) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Ref getRef(int i) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Blob getBlob(int i) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Clob getClob(int i) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Array getArray(int i) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Object getObject(String colName, Map map) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Ref getRef(String colName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Blob getBlob(String colName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Clob getClob(String colName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Array getArray(String colName) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Date getDate(int columnIndex, Calendar cal) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Date getDate(String columnName, Calendar cal) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Time getTime(int columnIndex, Calendar cal) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Time getTime(String columnName, Calendar cal) throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Timestamp getTimestamp(int columnIndex, Calendar cal)
                                                       throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }

  public Timestamp getTimestamp(String columnName, Calendar cal)
                                                       throws SQLException {
    throw new SQLException("gweMysqlVectorResultSet does not support this method.");
  }


  /////////////// implements ResultSetMetaData ////////////////////////////
  public int getColumnCount() throws SQLException {
    return cols.length;
  }

  public boolean isAutoIncrement(int column) throws SQLException {
    return false;
  }

  public boolean isCaseSensitive(int column) throws SQLException {
    return true;
  }

  public boolean isSearchable(int column) throws SQLException {
    return true;
  }

  public boolean isCurrency(int column) throws SQLException {
    return false;
  }

  public int isNullable(int column) throws SQLException {
    return columnNoNulls;
  }

  public boolean isSigned(int column) throws SQLException {
    return false;
  }

  public int getColumnDisplaySize(int column) throws SQLException {
    int max_size = 1;
    for(int i = 0; i < rows.size(); i++)
    {
      ArrayList rowdata = (ArrayList)rows.get(i);
      Object data = rowdata.get(column-1);
      if( data == null )
        continue;
      int temp_len = data.toString().length();
      if( temp_len > max_size )
        max_size = temp_len;
    }
    return max_size;
  }

  public String getColumnLabel(int column) throws SQLException {
    return cols[column-1].getName();
  }

  public String getColumnName(int column) throws SQLException {
    return cols[column-1].getName();
  }

  public String getSchemaName(int column) throws SQLException {
    return "";
  }

  public int getPrecision(int column) throws SQLException {
    return 0;
  }

  public int getScale(int column) throws SQLException {
    return 0;
  }

  public String getTableName(int column) throws SQLException {
    return cols[column-1].getTable();
  }

  public String getCatalogName(int column) throws SQLException {
    return "";
  }

  public int getColumnType(int column) throws SQLException {
    gweMysqlColumn col = cols[column-1];
    switch (col.getType()) {
      case gweMysqlMetaResult.FIELD_TYPE_DECIMAL     : return Types.DECIMAL;
      case gweMysqlMetaResult.FIELD_TYPE_TINY        : return Types.TINYINT;
      case gweMysqlMetaResult.FIELD_TYPE_SHORT       : return Types.SMALLINT;
      case gweMysqlMetaResult.FIELD_TYPE_LONG        : return Types.INTEGER;
      case gweMysqlMetaResult.FIELD_TYPE_FLOAT       : return Types.FLOAT;
      case gweMysqlMetaResult.FIELD_TYPE_DOUBLE      : return Types.DOUBLE;
      case gweMysqlMetaResult.FIELD_TYPE_NULL        : return Types.NULL;
      case gweMysqlMetaResult.FIELD_TYPE_TIMESTAMP   : return Types.TIMESTAMP;
      case gweMysqlMetaResult.FIELD_TYPE_LONGLONG    : return Types.BIGINT;
      case gweMysqlMetaResult.FIELD_TYPE_INT24       : return Types.INTEGER;
      case gweMysqlMetaResult.FIELD_TYPE_DATE        : return Types.DATE;
      case gweMysqlMetaResult.FIELD_TYPE_TIME        : return Types.TIME;
      case gweMysqlMetaResult.FIELD_TYPE_DATETIME    : return Types.TIMESTAMP;
      case gweMysqlMetaResult.FIELD_TYPE_NEWDATE     : return Types.DATE;
      case gweMysqlMetaResult.FIELD_TYPE_ENUM        : return Types.CHAR;
      case gweMysqlMetaResult.FIELD_TYPE_SET         : return Types.CHAR;
      case gweMysqlMetaResult.FIELD_TYPE_TINY_BLOB   : return Types.VARBINARY;
      case gweMysqlMetaResult.FIELD_TYPE_MEDIUM_BLOB : return Types.LONGVARBINARY;
      case gweMysqlMetaResult.FIELD_TYPE_LONG_BLOB   : return Types.LONGVARBINARY;
      case gweMysqlMetaResult.FIELD_TYPE_BLOB        : //return Types.LONGVARBINARY;
        // Thanks for INDEN-san
        if( col.isBinary() ) return Types.LONGVARBINARY;
        return Types.LONGVARCHAR;
      case gweMysqlMetaResult.FIELD_TYPE_VAR_STRING  : return Types.VARCHAR;
      case gweMysqlMetaResult.FIELD_TYPE_STRING      : return Types.CHAR;
      case gweMysqlMetaResult.FIELD_TYPE_YEAR        : return Types.SMALLINT; // YEAR support!!
      default : throw new SQLException("Unknown data type.");
    }
  }

  public String getColumnTypeName(int column) throws SQLException {
    gweMysqlColumn col = cols[column-1];
    switch (col.getType()) {
      case gweMysqlMetaResult.FIELD_TYPE_DECIMAL:
        return "DECIMAL";
      case gweMysqlMetaResult.FIELD_TYPE_TINY:
        return "TINY";
      case gweMysqlMetaResult.FIELD_TYPE_SHORT:
        return "SHORT";
      case gweMysqlMetaResult.FIELD_TYPE_LONG:
        return "LONG";
      case gweMysqlMetaResult.FIELD_TYPE_FLOAT:
        return "FLOAT";
      case gweMysqlMetaResult.FIELD_TYPE_DOUBLE:
        return "DOUBLE";
      case gweMysqlMetaResult.FIELD_TYPE_NULL:
        return "NULL";
      case gweMysqlMetaResult.FIELD_TYPE_TIMESTAMP:
        return "TIMESTAMP";
      case gweMysqlMetaResult.FIELD_TYPE_LONGLONG:
        return "LONGLONG";
      case gweMysqlMetaResult.FIELD_TYPE_INT24:
        return "INT";
      case gweMysqlMetaResult.FIELD_TYPE_DATE:
        return "DATE";
      case gweMysqlMetaResult.FIELD_TYPE_TIME:
        return "TIME";
      case gweMysqlMetaResult.FIELD_TYPE_DATETIME:
        return "DATETIME";
      case gweMysqlMetaResult.FIELD_TYPE_TINY_BLOB:
        return "TINYBLOB";
      case gweMysqlMetaResult.FIELD_TYPE_MEDIUM_BLOB:
        return "MEDIUMBLOB";
      case gweMysqlMetaResult.FIELD_TYPE_LONG_BLOB:
        return "LONGBLOB";
      case gweMysqlMetaResult.FIELD_TYPE_BLOB:
//        return "BLOB";
        // Thanks for INDEN-san
        if( col.isBinary() ) return "LONGBLOB";
        return "LONGTEXT";
      case gweMysqlMetaResult.FIELD_TYPE_VAR_STRING:
        return "VARCHAR";
      case gweMysqlMetaResult.FIELD_TYPE_STRING:
        return "CHAR";
      case gweMysqlMetaResult.FIELD_TYPE_ENUM:
        return "ENUM";
      case gweMysqlMetaResult.FIELD_TYPE_SET:
        return "SET";
      case gweMysqlMetaResult.FIELD_TYPE_YEAR:
        return "YEAR"; // YEAR support!!
      default:
        return "UNKNOWN";
    }
  }

  public boolean isReadOnly(int column) throws SQLException {
    return false;
  }

  public boolean isWritable(int column) throws SQLException {
    return true;
  }

  public boolean isDefinitelyWritable(int column) throws SQLException {
    return true;
  }

  public String getColumnClassName(int column) throws SQLException {
    throw new SQLException("mysql does not support getColumnClassName(int).");
  }
}
